unit Unit1;

interface

uses
   Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
   Vcl.Controls, Vcl.Forms, Vcl.Dialogs, VclTee.TeeGDIPlus, VclTee.TeEngine,
   VclTee.Series, VclTee.TeePolar, Vcl.ExtCtrls, VclTee.TeeProcs, VclTee.Chart,
   VclTee.DBChart, Vcl.StdCtrls;

type
   TForm1 = class(TForm)
      SMEChart: TDBChart;
      SeriesAussenring: TPolarSeries;
      SeriesGutring: TPolarSeries;
      SeriesInnenring: TPolarSeries;
      SeriesMesskurve: TPolarSeries;
    Button1: TButton;
      procedure FormCreate(Sender: TObject);
      procedure RefreshValues( vXValue, vRadius : double);
    procedure Button1Click(Sender: TObject);
   private
      { Private-Deklarationen }
      AngleOffset : double;
      nValuesReal : integer;
      CurrentAngle, CurrentRadius : double;
   public
      { Public-Deklarationen }
   end;

var
   Form1: TForm1;

implementation

{$R *.dfm}



procedure TForm1.FormCreate(Sender: TObject);
var
   j: integer;
   mb, tr: double;
begin
   AngleOffset := 20.0;
   nValuesReal := 360;
   mb := 1000.0;
   SMEChart.LeftAxis.Automatic := false;
   SMEChart.LeftAxis.SetMinMax(-mb, mb);
   SMEChart.BottomAxis.Automatic := false;
   SMEChart.BottomAxis.SetMinMax(-mb, mb);
   CurrentAngle := 0.0;
   CurrentRadius := 0.0;
   SeriesMesskurve.Clear;

   SeriesAussenring.Visible := true;
   SeriesGutring.Visible := true;
   SeriesInnenring.Visible := true;
   SeriesMesskurve.Visible := true;
   SeriesAussenring.Clear;
   SeriesGutring.Clear;
   SeriesInnenring.Clear;

   tr := 400.0;
   for j := 0 to 359 do begin
      SeriesAussenring.AddPolar(j, mb);
      SeriesGutring.AddPolar(j, tr);
      SeriesInnenring.AddPolar(j, 0);
   end;
   SeriesMesskurve.Clear;
end;


procedure TForm1.Button1Click(Sender: TObject);
begin
   RefreshValues( CurrentAngle, CurrentRadius );
   CurrentAngle := CurrentAngle + 1.0;
   CurrentRadius := CurrentRadius + 1.0;
end;


// Draw one point
procedure TForm1.RefreshValues( vXValue, vRadius : double);
var
   i, j, k, n, r: integer;
   x, y, wert, mr: double;
   xscale, d, sTol: double;
   td: int64;
   bb: boolean;
   fg, bk: TColor;
begin
   xscale := 360.0 / nValuesReal;
   x := vXValue * xscale;
   // Winkelversatz einbeziehen
   x := x + AngleOffset;
   if x > 360.0 then
      x := x - 360.0
   else if x < 0.0 then
      x := x + 360;

   y := vRadius;
   // Each point is defined by an angle and a radius.
   // Angle values correspond to X values and Radius correspond to Y values.
   SeriesMesskurve.AddPolar(x, y);
end;

end.
